module AppRail
  module Airtable
    module AuthenticationHelpers
      def current_user
        @current_user ||= find_current_user
      end
  
      def find_current_user
        authorization_header && bearer_token ? find_authenticatable_resource(access_token: bearer_token) : nil
      end
  
      def bearer_token
        authorization_values = authorization_header.split(" ")
        return nil unless authorization_values.count > 1
        authorization_values[1]
      end
  
      def authorization_header
        request.env["HTTP_AUTHORIZATION"]
      end
  
      def authenticate!
        halt 401 unless current_user
      end
    end
  end
end